#!/usr/bin/env python3
#
# absServices.py
# last modified - Friday, 11/06/2020
# c2007-2020 by Paul Sherman   http://www.pcbypaul.com
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 3
# of the License, or (at your option) any later version.
#
import os, subprocess, gi
gi.require_version('Gtk', '3.0')
gi.require_version('PangoCairo', '1.0')
gi.require_version("Gdk", "3.0")
from gi.repository import Gtk, Gdk, GdkPixbuf, Pango, PangoCairo

icon_xpm = [
"32 32 3 1",
" 	c None",
".	c #3700A4",
"+	c #FF0037",
"              ...               ",
"              ...     .         ",
"       ..    ......  ...        ",
"      ..................        ",
"       ................         ",
"       .......    ...           ",
"      .....           ++++      ",
"     .....           ++++++     ",
"  .......           ++++++++    ",
" .......            ++++++++    ",
"  .....             ++++++++    ",
"   ....             ++++++++    ",
"   ...              ++++++++    ",
"   ...              ++++++++    ",
"  ....               ++++++     ",
"......                ++++      ",
"......                          ",
"......           +++++    +++++ ",
"  ....           ++++++  +++++++",
"   ...          +++++++  +++++++",
"   ....         +++++++  +++++++",
"    ...         +++++++  +++++++",
"   .....        ++++++++++++++++",
"  .......       ++++++++++++++++",
"  ........      ++++++++++++++++",
"   .  ......    ++++++++++++++++",
"       ........ ++++++++++++++++",
"        ....... ++++++++++++++++",
"        ....... ++++++++++++++++",
"       ....   .  ++++++++++++++ ",
"         .         +++++++++++  ",
"                     ++++++     "
]

style_provider = Gtk.CssProvider()
css = b"""
*.alteredstate{
color:red;
}
"""
style_provider.load_from_data(css)
Gtk.StyleContext.add_provider_for_screen(
    Gdk.Screen.get_default(), 
    style_provider,     
    Gtk.STYLE_PROVIDER_PRIORITY_APPLICATION
)

class Grid(Gtk.Window):
	widget_list = []
	WIDGET_SIZE = 140
	COLS = 1
	NUM = 100

	def SetState(self, event, state):
		if (event.get_active() != state):
			event.get_style_context().add_class('alteredstate')
		else:
			event.get_style_context().remove_class('alteredstate')

		for kid in self.grid_main.get_children():

			if "CheckButton" in (str(type(kid))):
				style_context = kid.get_style_context()
				fgcolor = str(style_context.get_color(Gtk.StateType.NORMAL))
				if "red=1" in fgcolor:
					self.apply_btn.set_sensitive(1)
					break
				else:
					self.apply_btn.set_sensitive(0)


	def delete_event(self, window=None, event=None):
		Gtk.main_quit()
		
		
	def create_grid(self):
		grid = Gtk.Grid()
		grid.set_column_spacing(10)
		grid.set_row_spacing(10)
		grid.set_column_homogeneous(True)
		grid.set_row_homogeneous(False)
		grid.set_border_width(24)
		return grid

	def ApplyChanges(self, event):
	
		try:
			if self.cb2.get_active() != self.cups_state:
				if self.cb2.get_active() == True:
					os.chmod("/etc/rc.d/rc.cups", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.cups", 0o644)
		except:
			pass	
			
		try:
			if self.cb3.get_active() != self.nm_state:
				if self.cb3.get_active() == True:
					os.chmod("/usr/bin/nm-applet", 0o755)
					os.chmod("/etc/rc.d/rc.networkmanager", 0o755)
					os.system("echo 'deathstar.absolute.net' > /etc/HOSTNAME")
					os.system("echo '127.0.0.1	localhost' > /etc/hosts")
					os.system("echo '127.0.0.1	deathstar.absolute.net	deathstar' >> /etc/hosts")
				else:
					os.chmod("/usr/bin/nm-applet", 0o644)
					os.chmod("/etc/rc.d/rc.networkmanager", 0o644)
		except:
			pass	

		
		try:
			if self.cb4.get_active() != self.bind_state:
				if self.cb4.get_active() == True:
					os.chmod("/etc/rc.d/rc.bind", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.bind", 0o644)
		except:
			pass	
			
		try:
			if self.cb5.get_active() != self.dnsmasq_state:
				if self.cb5.get_active() == True:
					os.chmod("/etc/rc.d/rc.dnsmasq", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.dnsmasq", 0o644)
		except:
			pass	
			
		try:
			if self.cb6.get_active() != self.httpd_state:
				if self.cb6.get_active() == True:
					os.chmod("/etc/rc.d/rc.httpd", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.httpd", 0o644)
		except:
			pass												

		try:
			if self.cb7.get_active() != self.inetd_state:
				if self.cb7.get_active() == True:
					os.chmod("/etc/rc.d/rc.inetd", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.inetd", 0o644)
		except:
			pass												


		try:
			if self.cb8.get_active() != self.ip_forward_state:
				if self.cb8.get_active() == True:
					os.chmod("/etc/rc.d/rc.ip_forward", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.ip_forward", 0o644)
		except:
			pass												

		try:
			if self.cb9.get_active() != self.mysqld_state:
				if self.cb9.get_active() == True:
					os.chmod("/etc/rc.d/rc.mysqld", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.mysqld", 0o644)
		except:
			pass												

		try:
			if self.cb10.get_active() != self.pcmcia_state:
				if self.cb10.get_active() == True:
					os.chmod("/etc/rc.d/rc.pcmcia", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.pcmcia", 0o644)
		except:
			pass												

		try:
			if self.cb11.get_active() != self.rpc_state:
				if self.cb11.get_active() == True:
					os.chmod("/etc/rc.d/rc.rpc", 0o755)
					os.chmod("/etc/rc.d/rc.nfsd", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.rpc", 0o644)
					os.chmod("/etc/rc.d/rc.rnfsd", 0o644)
		except:
			pass												

		try:
			if self.cb12.get_active() != self.samba_state:
				if self.cb12.get_active() == True:
					os.chmod("/etc/rc.d/rc.samba", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.samba", 0o644)
		except:
			pass												

		try:
			if self.cb13.get_active() != self.saslauthd_state:
				if self.cb13.get_active() == True:
					os.chmod("/etc/rc.d/rc.saslauthd", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.saslauthd", 0o644)
		except:
			pass												

		try:
			if self.cb14.get_active() != self.sendmail_state:
				if self.cb14.get_active() == True:
					os.chmod("/etc/rc.d/rc.sendmail", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.sendmail", 0o644)
		except:
			pass												

		try:
			if self.cb15.get_active() != self.syslog_state:
				if self.cb15.get_active() == True:
					os.chmod("/etc/rc.d/rc.syslog", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.syslog", 0o644)
		except:
			pass												

		try:
			if self.cb16.get_active() != self.sshd_state:
				if self.cb16.get_active() == True:
					os.chmod("/etc/rc.d/rc.sshd", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.sshd", 0o644)
		except:
			pass	
			
		try:
			if self.cb17.get_active() != self.crond_state:
				if self.cb17.get_active() == True:
					os.chmod("/usr/sbin/crond", 0o755)
				else:
					os.chmod("/usr/sbin/crond", 0o644)
		except:
			pass				

		try:
			if self.cb18.get_active() != self.smartd_state:
				if self.cb18.get_active() == True:
					os.chmod("/etc/rc.d/rc.smartd", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.smartd", 0o644)
		except:
			pass	

		try:
			if self.cb19.get_active() != self.atalk_state:
				if self.cb19.get_active() == True:
					os.chmod("/usr/sbin/atalk", 0o755)
				else:
					os.chmod("/usr/sbin/atalk", 0o644)
		except:
			pass	
			
		try:
			if self.cb20.get_active() != self.atspi_state:
				if self.cb20.get_active() == True:
					os.chmod("/usr/libexec/at-spi-bus-launcher", 0o755)
				else:
					os.chmod("/usr/libexec/at-spi-bus-launcher", 0o644)
		except:
			pass

		try:
			if self.cb21.get_active() != self.bluetooth_state:
				if self.cb21.get_active() == True:
					os.chmod("/etc/rc.d/rc.bluetooth", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.bluetooth", 0o644)
		except:
			pass
		
		try:
			if self.cb22.get_active() != self.openldap_state:
				if self.cb22.get_active() == True:
					os.chmod("/etc/rc.d/rc.openldap", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.openldap", 0o644)
		except:
			pass

		try:
			if self.cb23.get_active() != self.openvpn_state:
				if self.cb23.get_active() == True:
					os.chmod("/etc/rc.d/rc.openvpn", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.openvpn", 0o644)
		except:
			pass
		
		try:
			if self.cb24.get_active() != self.nfsd_state:
				if self.cb24.get_active() == True:
					os.chmod("/etc/rc.d/rc.nfsd", 0o755)
				else:
					os.chmod("/etc/rc.d/rc.nfsd", 0o644)
		except:
			pass
			
		box = Gtk.MessageDialog(parent=None, flags=0, message_type=Gtk.MessageType.INFO, buttons=Gtk.ButtonsType.OK, text='\nThe changes have been applied.')
		box.set_position(Gtk.WindowPosition.CENTER)
		box.set_title('Changes made to services')
		box.set_transient_for(self)
		box.run()
		box.destroy()	
		self.delete_event()
		

	def __init__(self):

		Gtk.Window.__init__(self, title="Services")

		self.resize(346, 662)
		self.set_position(Gtk.WindowPosition.CENTER)
		
		icon = GdkPixbuf.Pixbuf.new_from_xpm_data(icon_xpm)
		self.set_icon(icon)

		self.grid_main = self.create_grid()
		viewport = Gtk.Viewport(hadjustment=None, vadjustment=None);
		viewport.add(self.grid_main)
		viewport.set_shadow_type (Gtk.ShadowType.NONE)
		scroll = Gtk.ScrolledWindow()
		scroll.set_border_width(0)
		scroll.add(viewport)
		scroll.set_policy(Gtk.PolicyType.AUTOMATIC, Gtk.PolicyType.AUTOMATIC)
		self.add(scroll)

		lbl_services = Gtk.Label.new("Select Services")
		lbl_services.set_markup('<span size="16000" foreground="#22518E"><b>Select Services</b></span>')
		self.grid_main.attach(lbl_services, 0, 0, 2, 1)
		
		
		lbl_services_desc = Gtk.Label.new("to run on system startup")
		lbl_services_desc.set_markup('<span size="10000">to run on startup (default are in bold)</span>')
		self.grid_main.attach(lbl_services_desc, 0, 1, 2, 1)

		sep = Gtk.Separator.new(Gtk.Orientation.HORIZONTAL)
		self.grid_main.attach(sep, 0, 2, 2, 1)
		
		if os.access("/etc/rc.d/rc.cups", os.R_OK):
			self.cb2 = Gtk.CheckButton(label="")
			self.cb2.get_children()[0].set_markup(" <b>CUPS print server</b>")
			self.grid_main.attach(self.cb2, 0, 3, 2, 1)
			self.cb2.set_tooltip_text('The Common UNIX Printing system. \nIf you have a printer connected, you will want this.')	 
			self.cups_state = False
			if os.access("/etc/rc.d/rc.cups", os.X_OK):
				self.cb2.set_active(True)
				self.cups_state = True
			self.cb2.connect("toggled", self.SetState, self.cups_state)

		if os.access("/etc/rc.d/rc.networkmanager", os.R_OK):
			self.cb3 = Gtk.CheckButton(label="")
			self.cb3.get_children()[0].set_markup(" <b>Network Manager</b>")
			self.grid_main.attach(self.cb3, 0, 4, 2, 1)
			self.cb3.set_tooltip_text('Needed for wireless hookups,\n also used by default on Absolute to control wired connections.')	 
			self.nm_state = False
			if os.access("/etc/rc.d/rc.networkmanager", os.X_OK):
				self.cb3.set_active(True)
				self.nm_state = True
			self.cb3.connect("toggled", self.SetState, self.nm_state)	

		if os.access("/etc/rc.d/rc.bind", os.R_OK):
			self.cb4 = Gtk.CheckButton(label=" BIND server")
			self.grid_main.attach(self.cb4, 0, 5, 2, 1)
			self.cb4.set_tooltip_text('BIND (Berkeley Internet Name Domain)\nis a Domain Name System (DNS) server.')	 
			self.bind_state = False
			if os.access("/etc/rc.d/rc.bind", os.X_OK):
				self.cb4.set_active(True)
				self.bind_state = True
			self.cb4.connect("toggled", self.SetState, self.bind_state)		
				
		if os.access("/etc/rc.d/rc.dnsmasq", os.R_OK):
			self.cb5 = Gtk.CheckButton(label=" dnsmasq DHCP/DNS server")
			self.grid_main.attach(self.cb5, 0, 6, 2, 1)
			self.cb5.set_tooltip_text('DNS forwarder and DHCP server.\n[Not needed for a client -- for example, to connect to cable internet service.]')	 
			self.dnsmasq_state = False
			if os.access("/etc/rc.d/rc.dnsmasq", os.X_OK):
				self.cb5.set_active(True)
				self.dnsmasq_state = True
			self.cb5.connect("toggled", self.SetState, self.dnsmasq_state)
							
		if os.access("/etc/rc.d/rc.httpd", os.R_OK):
			self.cb6 = Gtk.CheckButton(label=" The Apache web server")
			self.grid_main.attach(self.cb6, 0, 7, 2, 1)
			self.cb6.set_tooltip_text('Apache, the most widely used web server on the net.')	 
			self.httpd_state = False
			if os.access("/etc/rc.d/rc.httpd", os.X_OK):
				self.cb6.set_active(True)
				self.httpd_state = True
			self.cb6.connect("toggled", self.SetState, self.httpd_state)

		if os.access("/etc/rc.d/rc.inetd", os.R_OK):
			self.cb7 = Gtk.CheckButton(label=" The BSD Inetd daemon")
			self.grid_main.attach(self.cb7, 0, 8, 2, 1)
			self.cb7.set_tooltip_text('Inetd daemon (this allows:  time, ftp, wx.comsat, talk, finger, and auth).')	 
			self.inetd_state = False
			if os.access("/etc/rc.d/rc.inetd", os.X_OK):
				self.cb7.set_active(True)
				self.inetd_state = True
			self.cb7.connect("toggled", self.SetState, self.inetd_state)

		if os.access("/etc/rc.d/rc.ip_forward", os.R_OK):
			self.cb8 = Gtk.CheckButton(label=" Activate IP packet forwarding")
			self.grid_main.attach(self.cb8, 0, 9, 2, 1)
			self.cb8.set_tooltip_text('Packet forwarding allows your Linux machine to act as a router.')	 
			self.ip_forward_state = False
			if os.access("/etc/rc.d/rc.ip_forward", os.X_OK):
				self.cb8.set_active(True)
				self.ip_forward_state = True
			self.cb8.connect("toggled", self.SetState, self.ip_forward_state)			
											
		if os.access("/etc/rc.d/rc.mysqld", os.R_OK):
			self.cb9 = Gtk.CheckButton(label=" The MySQL database server")
			self.grid_main.attach(self.cb9, 0, 10, 2, 1)
			self.cb9.set_tooltip_text('MySQL, an SQL-based relational database daemon.')	 
			self.mysqld_state = False
			if os.access("/etc/rc.d/rc.mysqld", os.X_OK):
				self.cb9.set_active(True)
				self.mysqld_state = True
			self.cb9.connect("toggled", self.SetState, self.mysqld_state)

		if os.access("/etc/rc.d/rc.pcmcia", os.R_OK):
			self.cb10 = Gtk.CheckButton(label=" PCMCIA/Cardbus card services")
			self.grid_main.attach(self.cb10, 0, 11, 2, 1)
			self.cb10.set_tooltip_text('This supports PCMCIA or Cardbus cards used with laptops.')	 
			self.pcmcia_state = False
			if os.access("/etc/rc.d/rc.pcmcia", os.X_OK):
				self.cb10.set_active(True)
				self.pcmcia_state = True
			self.cb10.connect("toggled", self.SetState, self.pcmcia_state)

		if os.access("/etc/rc.d/rc.rpc", os.R_OK):
			self.cb11 = Gtk.CheckButton(label=" NFS (Network FileSystem) daemon")
			self.grid_main.attach(self.cb11, 0, 12, 2, 1)
			self.cb11.set_tooltip_text('Needed to serve or mount NFS (Network File System) partitions.')	 
			self.rpc_state = False
			if os.access("/etc/rc.d/rc.rpc", os.X_OK):
				self.cb11.set_active(True)
				self.rpc_state = True
			self.cb11.connect("toggled", self.SetState, self.rpc_state)

		if os.access("/etc/rc.d/rc.samba", os.R_OK):
			self.cb12 = Gtk.CheckButton(label=" The Samba file/print server")
			self.grid_main.attach(self.cb12, 0, 13, 2, 1)
			self.cb12.set_tooltip_text('Samba is a file and print server for Windows networks.')	 
			self.samba_state = False
			if os.access("/etc/rc.d/rc.samba", os.X_OK):
				self.cb12.set_active(True)
				self.samba_state = True
			self.cb12.connect("toggled", self.SetState, self.samba_state)
			
		if os.access("/etc/rc.d/rc.saslauthd", os.R_OK):
			self.cb13 = Gtk.CheckButton(label=" The SASL authentication server")
			self.grid_main.attach(self.cb13, 0, 14, 2, 1)
			self.cb13.set_tooltip_text('SASL is an authentication method often used by mail servers.')	 
			self.saslauthd_state = False
			if os.access("/etc/rc.d/rc.saslauthd", os.X_OK):
				self.cb13.set_active(True)
				self.saslauthd_state = True
			self.cb13.connect("toggled", self.SetState, self.saslauthd_state)						

		if os.access("/etc/rc.d/rc.sendmail", os.R_OK):
			self.cb14 = Gtk.CheckButton(label=" The Sendmail mail server")
			self.grid_main.attach(self.cb14, 0, 15, 2, 1)
			self.cb14.set_tooltip_text('The Sendmail server allows your machine to send and receive mail.\nNOT needed if you use a mail client (such as Sylpheed or Firebird) to send and recieve mail from your ISP.')	 
			self.sendmail_state = False
			if os.access("/etc/rc.d/rc.sendmail", os.X_OK):
				self.cb14.set_active(True)
				self.sendmail_state = True
			self.cb14.connect("toggled", self.SetState, self.sendmail_state)						
						

		if os.access("/etc/rc.d/rc.syslog", os.R_OK):
			self.cb15 = Gtk.CheckButton(label=" The Linux system logging utilities")
			self.cb15.get_children()[0].set_markup(" <b>The Linux system logging utilities</b>")
			self.grid_main.attach(self.cb15, 0, 16, 2, 1)
			self.cb15.set_tooltip_text('The syslogd and klogd daemons log important messages under /var/log.')	 
			self.syslog_state = False
			if os.access("/etc/rc.d/rc.syslog", os.X_OK):
				self.cb15.set_active(True)
				self.syslog_state = True
			self.cb15.connect("toggled", self.SetState, self.syslog_state)
			
		if os.access("/etc/rc.d/rc.sshd", os.R_OK):
			self.cb16 = Gtk.CheckButton(label=" The SSHD (secure shell) daemon")
			self.cb16.get_children()[0].set_markup(" <b>The SSHD (secure shell) daemon</b>")
			self.grid_main.attach(self.cb16, 0, 17, 2, 1)
			self.cb16.set_tooltip_text('The SSHD (secure shell) daemon" $RC_SSHD "SSHD allows secure encrypted logins to your machine.')	 
			self.sshd_state = False
			if os.access("/etc/rc.d/rc.sshd", os.X_OK):
				self.cb16.set_active(True)
				self.sshd_state = True
			self.cb16.connect("toggled", self.SetState, self.sshd_state)
						
		if os.access("/usr/sbin/crond", os.R_OK):
			self.cb17 = Gtk.CheckButton(label=" crond command daemon")
			self.grid_main.attach(self.cb17, 0, 18, 2, 1)
			self.cb17.set_tooltip_text('crond - daemon to execute scheduled commands.')	 
			self.crond_state = False
			if os.access("/usr/sbin/crond", os.X_OK):
				self.cb17.set_active(True)
				self.crond_state = True
			self.cb17.connect("toggled", self.SetState, self.crond_state)

		if os.access("/etc/rc.d/rc.smartd", os.R_OK):
			self.cb18 = Gtk.CheckButton(label=" smart drive daemon")
			self.grid_main.attach(self.cb18, 0, 19, 2, 1)
			self.cb18.set_tooltip_text('atd - daemon to execute scheduled commands.')	 
			self.smartd_state = False
			if os.access("/etc/rc.d/rc.smartd", os.X_OK):
				self.cb18.set_active(True)
				self.smartd_state = True
			self.cb18.connect("toggled", self.SetState, self.smartd_state)	

		if os.access("/usr/sbin/atalk", os.R_OK):
			self.cb19 = Gtk.CheckButton(label=" Netatalk Appletalk file/print server")
			self.grid_main.attach(self.cb19, 0, 20, 2, 1)
			self.cb19.set_tooltip_text('The Netatalk server is a file and print server for Macintosh networks.')	 
			self.atalk_state = False
			if os.access("/usr/sbin/atalk", os.X_OK):
				self.cb19.set_active(True)
				self.atalk_state = True
			self.cb19.connect("toggled", self.SetState, self.atalk_state)			

		if os.access("/usr/libexec/at-spi-bus-launcher", os.R_OK):
			self.cb20 = Gtk.CheckButton(label="")
			self.cb20.get_children()[0].set_markup(" Accessibility Features (GTK)")
			self.grid_main.attach(self.cb20, 0, 21, 2, 1)
			self.cb20.set_tooltip_text('Assistive Technology - Service Provider Interface')	 
			self.atspi_state = False
			if os.access("/usr/libexec/at-spi-bus-launcher", os.X_OK):
				self.cb20.set_active(True)
				self.atspi_state = True
			self.cb20.connect("toggled", self.SetState, self.atspi_state)	
			
		if os.access("/etc/rc.d/rc.bluetooth", os.R_OK):
			self.cb21 = Gtk.CheckButton(label="")
			self.cb21.get_children()[0].set_markup(" Bluetooth")
			self.grid_main.attach(self.cb21, 0, 22, 2, 1)
			self.cb21.set_tooltip_text('Use Bluetooth devices')	 
			self.bluetooth_state = False
			if os.access("/etc/rc.d/rc.bluetooth", os.X_OK):
				self.cb21.set_active(True)
				self.bluetooth_state = True
			self.cb21.connect("toggled", self.SetState, self.bluetooth_state)	
			
		if os.access("/etc/rc.d/rc.openldap", os.R_OK):
			self.cb22 = Gtk.CheckButton(label="")
			self.cb22.get_children()[0].set_markup(" OpenLDAP server")
			self.grid_main.attach(self.cb22, 0, 23, 2, 1)
			self.cb22.set_tooltip_text('The stand-alone LDAP daemon (slapd)')	 
			self.openldap_state = False
			if os.access("/etc/rc.d/rc.openldap", os.X_OK):
				self.cb22.set_active(True)
				self.openldap_state = True
			self.cb22.connect("toggled", self.SetState, self.openldap_state)	
			
		if os.access("/etc/rc.d/rc.openvpn", os.R_OK):
			self.cb23 = Gtk.CheckButton(label="")
			self.cb23.get_children()[0].set_markup(" OpenVPN daemon")
			self.grid_main.attach(self.cb23, 0, 24, 2, 1)
			self.cb23.set_tooltip_text('A secure IP tunnel daemon')	 
			self.openvpn_state = False
			if os.access("/etc/rc.d/rc.openvpn", os.X_OK):
				self.cb23.set_active(True)
				self.openvpn_state = True
			self.cb23.connect("toggled", self.SetState, self.openvpn_state)	
			
		if os.access("/etc/rc.d/rc.nfsd", os.R_OK):
			self.cb24 = Gtk.CheckButton(label="")
			self.cb24.get_children()[0].set_markup(" NFS daemon")
			self.grid_main.attach(self.cb24, 0, 25, 2, 1)
			self.cb24.set_tooltip_text('NFS file sharing')	 
			self.nfsd_state = False
			if os.access("/etc/rc.d/rc.nfsd", os.X_OK):
				self.cb24.set_active(True)
				self.nfsd_state = True
			self.cb24.connect("toggled", self.SetState, self.nfsd_state)	
			
						
		self.apply_btn = Gtk.Button.new_with_label(" Apply ")
		self.close_btn = Gtk.Button.new_with_label(" Close ")	
			
		self.close_btn.connect("clicked", self.delete_event)
		self.apply_btn.connect("clicked", self.ApplyChanges)

		self.close_btn.get_children()[0].set_markup("<big><b>Close</b></big>")
		self.apply_btn.get_children()[0].set_markup("<big><b>Apply</b></big>")
		
		sep1 = Gtk.Separator.new(Gtk.Orientation.HORIZONTAL)
		self.grid_main.attach(sep1, 0, 25, 2, 1)
		
		self.apply_btn.set_sensitive(0)
		self.grid_main.attach(self.apply_btn, 0, 26, 1, 1)
		self.grid_main.attach(self.close_btn, 1, 26, 1, 1)
		
		
win = Grid()
win.connect("delete-event", Gtk.main_quit)
win.show_all()
Gtk.main()
